diff -r f6ef988fda71 trytond/model/modelstorage.py
--- a/trytond/model/modelstorage.py	Fri Sep 21 16:04:02 2012 +0200
+++ b/trytond/model/modelstorage.py	Sun Sep 23 17:30:03 2012 +0200
@@ -1192,3 +1106,287 @@
             else:
                 vals[field] = defaults[field]
         return vals
+
+    def __init__(self, id=None, **kwargs):
+        _ids = kwargs.pop('_ids', None)
+        _local_cache = kwargs.pop('_local_cache', None)
+        super(ModelStorage, self).__init__(id, **kwargs)
+        self._cursor = Transaction().cursor
+        self._user = Transaction().user
+        self._context = Transaction().context
+        if _ids is not None:
+            self._ids = _ids
+            assert id in _ids
+        else:
+            self._ids = [self.id]
+
+        self._cursor_cache = self._cursor.get_cache(self._context)
+
+        if _local_cache is not None:
+            self._local_cache = _local_cache
+        else:
+            self._local_cache = LRUDict(RECORD_CACHE_SIZE)
+        self._local_counter = Transaction().counter
+
+    @property
+    def _cache(self):
+        cache = self._cursor_cache
+        if self.__name__ not in cache:
+            cache[self.__name__] = LRUDict(RECORD_CACHE_SIZE)
+        return cache[self.__name__]
+
+    def __getattr__(self, name):
+        try:
+            return super(ModelStorage, self).__getattr__(name)
+        except AttributeError:
+            if self.id < 0:
+                raise
+
+        counter = Transaction().counter
+        if self._local_counter != counter:
+            self._local_cache.clear()
+            self._local_counter = counter
+        try:
+            return self._local_cache[self.id][name]
+        except KeyError:
+            pass
+        try:
+            return self._cache[self.id][name]
+        except KeyError:
+            pass
+
+        # fetch the definition of the field
+        if name in self._fields:
+            field = self._fields[name]
+        elif name in self._inherit_fields:
+            field = self._inherit_fields[name][2]
+        else:
+            raise AttributeError("'%s' Model has no attribute '%s'"
+                % (self.__name__, name))
+
+        # build the list of fields we will fetch
+        ffields = {
+            name: field,
+            }
+        if field.loading == 'eager':
+            FieldAccess = Pool().get('ir.model.field.access')
+            fread_accesses = {}
+            for inherit_name in self._inherits:
+                Inherit = Pool().get(inherit_name)
+                fread_accesses.update(FieldAccess.check(inherit_name,
+                    Inherit._fields.keys(), 'read', access=True))
+            fread_accesses.update(FieldAccess.check(self.__name__,
+                self._fields.keys(), 'read', access=True))
+            to_remove = set(x for x, y in fread_accesses.iteritems()
+                    if not y and x != name)
+
+            threshold = BROWSE_FIELD_TRESHOLD
+            inherit_threshold = threshold - len(self._fields)
+
+            def not_cached(item):
+                fname, field = item
+                return (fname not in self._cache.get(self.id, {})
+                    and fname not in self._local_cache.get(self.id, {}))
+
+            def to_load(item):
+                fname, field = item
+                return (field.loading == 'eager'
+                    and fname not in to_remove)
+
+            def overrided(item):
+                fname, field = item
+                return fname in self._fields
+
+            if inherit_threshold > 0:
+                ifields = ((fname, field)
+                    for fname, (_, _, field) in
+                    self._inherit_fields.iteritems())
+                ifields = ifilterfalse(overrided,
+                    ifilter(to_load,
+                        ifilter(not_cached, ifields)))
+                ifields = islice(ifields, 0, inherit_threshold)
+                ffields.update(ifields)
+                threshold -= inherit_threshold
+
+            ifields = ifilter(to_load,
+                ifilter(not_cached,
+                    self._fields.iteritems()))
+            ifields = islice(ifields, 0, threshold)
+            ffields.update(ifields)
+
+        # add datetime_field
+        for field in ffields.values():
+            if hasattr(field, 'datetime_field') and field.datetime_field:
+                if field.datetime_field in self._fields:
+                    datetime_field = self._fields[field.datetime_field]
+                else:
+                    datetime_field = self._inherit_fields[
+                            field.datetime_field][2]
+                ffields[field.datetime_field] = datetime_field
+
+        def filter_(id_):
+            try:
+                if name in self._local_cache[id_]:
+                    return False
+                if name in self._cache[id_]:
+                    return False
+            except KeyError:
+                pass
+            return True
+        index = self._ids.index(self.id)
+        ids = chain(islice(self._ids, index, None),
+            islice(self._ids, 0, max(index - 1, 0)))
+        ids = list(islice(ifilter(filter_, ids), self._cursor.IN_MAX))
+
+        def instantiate(field, value, data):
+            if field._type in ('many2one', 'one2one', 'reference'):
+                if value is None or value is False:
+                    return None
+            elif field._type in ('one2many', 'many2many'):
+                if not value:
+                    return ()
+            try:
+                if field._type == 'reference':
+                    model_name, record_id = value.split(',')
+                    Model = Pool().get(model_name)
+                    try:
+                        value = int(record_id)
+                    except ValueError:
+                        return value
+                else:
+                    Model = field.get_target()
+            except KeyError:
+                return value
+            if getattr(field, 'datetime_field', None):
+                _datetime = data.get(field.datetime_field)
+            else:
+                _datetime = None
+            with Transaction().set_context(_datetime=_datetime):
+                local_cache = model2cache.setdefault(Model,
+                    LRUDict(RECORD_CACHE_SIZE))
+                ids = model2ids.setdefault(Model, [])
+                if field._type in ('many2one', 'one2one', 'reference'):
+                    ids.append(value)
+                    return Model(value, _ids=ids, _local_cache=local_cache)
+                elif field._type in ('one2many', 'many2many'):
+                    ids.extend(value)
+                    return tuple(Model(id, _ids=ids, _local_cache=local_cache)
+                        for id in value)
+
+        model2ids = {}
+        model2cache = {}
+        # Read the data
+        with contextlib.nested(Transaction().set_cursor(self._cursor),
+                Transaction().set_user(self._user),
+                Transaction().set_context(self._context)):
+            # create browse records for 'remote' models
+            for data in self.read(ids, ffields.keys()):
+                for fname, field in ffields.iteritems():
+                    if field._type in ('many2one', 'one2one', 'one2many',
+                            'many2many', 'reference'):
+                        data[fname] = instantiate(field, data[fname], data)
+                    elif not isinstance(field, fields.Function):
+                        continue
+                    if data['id'] == self.id and fname == name:
+                        value = data[fname]
+                    if data['id'] not in self._local_cache:
+                        self._local_cache[data['id']] = {}
+                    self._local_cache[data['id']][fname] = data[fname]
+                    del data[fname]
+                if data['id'] not in self._cache:
+                    self._cache[data['id']] = {}
+                self._cache[data['id']].update(data)
+                if data['id'] == self.id and name in data:
+                    value = data[name]
+        return value
+
+    @property
+    def _save_values(self):
+        values = {}
+        if not self._values:
+            return values
+        for fname, value in self._values.iteritems():
+            if fname in self._fields:
+                field = self._fields[fname]
+            else:
+                field = self._inherit_fields[fname][2]
+            if field._type in ('many2one', 'one2one', 'reference'):
+                if value:
+                    if value.id < 0 and field._type != 'reference':
+                        value.save()
+                    if field._type == 'reference':
+                        value = str(value)
+                    else:
+                        value = value.id
+            if field._type in ('one2many', 'many2many'):
+                targets = value
+                value = [
+                    ('set', []),
+                    ]
+                for target in targets:
+                    if target.id < 0:
+                        value.append(('create', target._save_values))
+                    elif target._save_values:
+                        value.append(
+                            ('write', [target.id], target._save_values))
+                    else:
+                        value[0][1].append(target.id)
+            values[fname] = value
+        return values
+
+    def save(self):
+        if self._save_values or self.id < 0:
+            with contextlib.nested(Transaction().set_cursor(self._cursor),
+                    Transaction().set_user(self._user),
+                    Transaction().set_context(self._context)):
+                if self.id < 0:
+                    self._ids.remove(self.id)
+                    self.id = self.create(self._save_values).id
+                    self._ids.append(self.id)
+                else:
+                    self.write([self], self._save_values)
+        self._values = None
+
+
+class EvalEnvironment(dict):
+
+    def __init__(self, record, Model):
+        super(EvalEnvironment, self).__init__()
+        self._record = record
+        self._model = Model
+
+    def __getitem__(self, item):
+        if item.startswith('_parent_'):
+            field = item[8:]
+            if field in self._model._fields:
+                model_name = self._model._fields[field].model_name
+            else:
+                model_name = self._model._inherit_fields[field][2].model_name
+            ParentModel = Pool().get(model_name)
+            return EvalEnvironment(getattr(self._record, field), ParentModel)
+        if (item in self._model._fields
+                or item in self._model._inherit_fields):
+            value = getattr(self._record, item)
+            if isinstance(value, Model):
+                return value.id
+            elif isinstance(value, list):
+                return [r.id for r in value]
+            else:
+                return value
+        return super(EvalEnvironment, self).__getitem__(item)
+
+    def __getattr__(self, item):
+        try:
+            return self.__getitem__(item)
+        except KeyError, exception:
+            raise AttributeError(*exception.args)
+
+    def get(self, item, default=None):
+        try:
+            return self.__getitem__(item)
+        except Exception:
+            pass
+        return super(EvalEnvironment, self).get(item, default)
+
+    def __nonzero__(self):
+        return bool(self._record)
